#include "kernel32.as"
#include "user32.as"

#ifndef __kansuji__
#ifdef __hsp3utf__
	#ifndef ___hsp3utf___
	#define global ___hsp3utf___
	#endif
#endif

#module muryo
#define add_l(%1,%2) %1=%2+%1
#define global ctype kansuji(%1=0,%2="",%3=0,%4=0,%5=0,%6=0,%7="[ї\]",%8=0) _kansuji(str(%1),%2,%3,%4,%5,%6,%7,%8)
#defcfunc _kansuji str _k_sce,str unit,int i_mode,int d_mode,int arab,int daiji,str jo,int jo_type,local k_scr,local kan_num,local kan_min,local kan_maj,local res1,local res2,local i_max,local d_min
	if k_initflag=0 {
		//
		sdim _kan_num,4,10
		_kan_num="Z","","","O","l","","Z","","",""
		sdim _kan_min,4,4
		_kan_min="","\","S",""
		sdim _kan_maj,13,17
		_kan_maj="","","","","","","","","a","","","",""
		_kan_maj(13)="P͍","m_","ߗR","svc"
		sdim kan_dec,24
		kan_dec="","","","","","","@","","o","","","","͌","畏","{k","u"
		kan_dec(16)="ew","","Z","","","","","ώ"
		dim rect,4
		k_initflag=1
	}
	sdim kan_num,4,10 : repeat 10 : kan_num(cnt)=_kan_num(cnt) : loop
	sdim kan_min,4,4 : repeat 4 : kan_min(cnt)=_kan_min(cnt) : loop
	sdim kan_maj,4,17 : repeat 17 : kan_maj(cnt)=_kan_maj(cnt) : loop
#ifdef ___hsp3utf___
	s="aaaa"
	if jo_type {
		lpoke s,0,0xB19DA5F0	//uv
	} else {
		lpoke s,0,0xADA7E7	//uv
	}
	kan_maj(6)=s
#else
	kan_maj(6)=jo
#endif
	switch daiji
		case 2
			kan_num(4)="","","","","J","" : kan_min(2)="","" : kan_maj(1)=""
		case 1
			kan_num(1)="","","Q" : kan_min(1)="E"
			swbreak
	swend
	if arab : kan_num="0","1","2","3","4","5","6","7","8","9"
	k_sce=_k_sce
	l=strlen(k_sce) : x=instr(k_sce,0,".") : if x=-1 : x=l
	i_max=x-1 : d_min=x+1
	res1="" : res2=""
	//
	x=i_max : n=0 : m=0
	no_int=0	//0tO
	if i_mode>0 {
		repeat
			if x<0 : break
			y=peek(k_sce,x)
			if y='-' {
				if arab : add_l res1,"-" : else : add_l res1,"}CiX"
			}
			if (y>='0')&(y<='9') {
				add_l res1,kan_num(y-'0')
				n++
				if (n\4=0)&(x>0) {
					n=0 : m++
					if m>=17 : m=0 : add_l res1,"ʑ吔"
					add_l res1,kan_maj(m)
				}
			}
			x--
		loop
	} else {
		sen=0	//uv̏ɁuvǉۗtO
		sen2=0	//1̏ꍇ͖Łuv̏Ɂuv
		maj=0	//io͍ς݃tO
		muryo=0	//ʑ吔X^bN
		repeat
			if x<0 : break
			y=peek(k_sce,x)
			if y='-' {
				if sen : add_l res1,kan_num(1) : sen=0
				if arab : add_l res1,"-" : else : add_l res1,"}CiX"
			}
			if (y>='0')&(y<='9') {
				z=y-'0'
				if z {
					if sen : add_l res1,kan_num(1) : sen=0
					if muryo : repeat muryo : add_l res1,"ʑ吔" : loop : muryo=0
					if maj=0 : add_l res1,kan_maj(m) : maj=1
					add_l res1,kan_min(n)
					if z=1 {
						if n=0 {
							add_l res1,kan_num(z)
						}
						if n=3 {
							if sen2=1 : add_l res1,kan_num(z) : else : sen=1
						}
					} else {
						add_l res1,kan_num(z)
					}
				}
				n++
				if n\4=0 {
					n=0 : m++ : sen2=1 : maj=0
					if m>=17 : m=0 : muryo++
				}
			}
			x--
		loop
	}
	if res1="" : no_int=1
	//
	x=d_min : n=0 : m=0 : w=(d_mode<0)	//w1̏ꍇ͖ŏo
	muryo=0	//ώÃtO
	muryo2=0	//ώÂ܂łɉ̏o͂tO
	repeat
		if x>=l : break
		y=peek(k_sce,x)
		if (y>='0')&(y<='9') {
			z=y-'0'
			if w|z {
				if muryo {
					if muryo2 : res2+="  " : muryo2=0
					repeat m
						res2+="ώÂ"
					loop
					muryo=0
				}
				muryo2=1
				res2+=kan_num(z)
				if d_mode<=0 : res2+=kan_dec(n)
			}
			n++
			if n=24 {
				n=0 : m++ : muryo=1
			}
		}
		x++
	loop
	//ʂ̕ҏW
	if no_int {
		if i_mode>0 : res1=kan_num(0) : else : if arab : res1="0" : else : res1=""
	}
	if res2="" {
		res=res1+unit
	} else {
		if d_mode>0 {
			res=res1+"."+res2+unit
		} else {
			if unit="" {
				if no_int {
					res=res2
				} else {
					res=res1+"  "+res2
				}
			} else {
				res=res1+unit+res2
			}
		}
	}
	return res

#define global mes_kansuji(%1=0,%2=0,%3=0,%4=0,%5="",%6=0,%7=0,%8=0,%9=0,%10=0) _mes_kansuji str(%1),%2,%3,%4,%5,%6,%7,%8,%9,%10
#deffunc _mes_kansuji str k_sce2,int _wid,int _hei,int dummy,str unit2,int i_mode2,int d_mode2,int arab2,int daiji2,int jo_type2,local buf0,local buf,local wid,local hei,local bmscr
	if jo_type2 : s="**" : else : s="*"
	buf0=_kansuji(k_sce2,unit2,i_mode2,d_mode2,arab2,daiji2,s,jo_type2)
	sdim buf,strlen(buf0)*2+2 : cnvstow buf,buf0	//UTF-16ɕϊ
	lstrlenW varptr(buf) : l=stat
#ifndef ___hsp3utf___
	//sjis̏ꍇ̂"*"uvoruvɒu
	repeat l
		if wpeek(buf,cnt*2)='*' {
			if jo_type2 : lpoke buf,cnt*2,0xDF71D855 : else : wpoke buf,cnt*2,0x79ED
		}
	loop
#endif
	rect=0,0,0,0
	if _wid<=0 : z=0x0 : else : z=0x10 : rect(2)=_wid	//DT_WORDBREAK=0x10
	if (_wid<=0)|(_hei<=0) {
		//`ɕKvȗ̈𒲂ׂ
		DrawTextW hdc,varptr(buf),-1,varptr(rect),0x400|z	//DT_CALCRECT=0x400
		hei=stat
		if _wid<=0 : wid=rect(2)-rect(0) : else : wid=_wid
	} else {
		wid=_wid : hei=_hei
	}
	x=ginfo_cx : y=ginfo_cy
	rect=x,y,x+wid,y+hei
	DrawTextW hdc,varptr(buf),-1,varptr(rect),z
	mref bmscr,67
	if bmscr(19)&0xFFFF0000 : redraw 1,x,y,wid,hei	//bmscr(19)̏16bitredrawԂ\Ă
	return

#global
#endif
