#include "user32.as" 
#uselib "user32.dll"
#func global SetWindowCompositionAttribute "SetWindowCompositionAttribute" int,int
#ifndef __compo_mod__
#define __compo_mod__

#module
#define ctype rgb2bgr(%1) ( (((%1)<<16)&0xFF0000) | ((%1)&0xFF00) | (((%1)>>16)&0xFF) )
#deffunc compo_init
	dim attr,3
	dim accent,4
	return

#define global alpha_window(%1=255) _alpha_window %1
#deffunc _alpha_window int aw_level
	if hwnd=0 : return
	if aw_level>=255 : normal_window : return
	GetWindowLong hwnd,-20
	SetWindowLong hwnd,-20,stat|0x80000	//WS_EX_LAYEREDt
	SetLayeredWindowAttributes hwnd,0,limit(aw_level,0,255),2	//LWA_ALPHAw
	return

#define global transcolor_window(%1=0) _transcolor_window %1
#deffunc _transcolor_window int tw_col
	if hwnd=0 : return
	GetWindowLong hwnd,-20
	SetWindowLong hwnd,-20,stat|0x80000	//WS_EX_LAYEREDt
	SetLayeredWindowAttributes hwnd,rgb2bgr(tw_col),0,1	//LWA_ALPHAw
	return

#deffunc normal_window
	if hwnd=0 : return
	GetWindowLong hwnd,-20
	SetWindowLong hwnd,-20,stat&0xFFF7FFFF	//WS_EX_LAYEREDO
	return

#define global accent_window(%1=0,%2=255,%3=0) _accent_window %1,%2,%3
#deffunc _accent_window int acw_type,int acw_level,int acw_color
	if hwnd=0 : return
	if varptr(SetWindowCompositionAttribute)=0 : return
	accent=acw_type,2,rgb2bgr(acw_color)|(limit(acw_level,0,255)<<24),0
	attr=19,varptr(accent),16	//WCA_ACCENT_POLICY = 19
	SetWindowCompositionAttribute hwnd,varptr(attr)
	return

#define global seven_window(%1=1) _compo_window %1,11	//WCA_THEME_ATTRIBUTES = 11
#define global reverse_window(%1=1) _compo_window %1,6	//WCA_NONCLIENT_RTL_LAYOUT = 6
#define global nothum_window(%1=1) _compo_window %1,7	//WCA_FORCE_ICONIC_REPRESENTATION = 7
#deffunc _compo_window int cw_switch,int cw_att
	if hwnd=0 : return
	if varptr(SetWindowCompositionAttribute)=0 : return
	accent=(cw_switch!=0),0,0,0
	attr=cw_att,varptr(accent),16
	SetWindowCompositionAttribute hwnd,varptr(attr)
	return


#global
compo_init

#endif
